<?php
/**
 * Documents the file following
 * @package googlemapsForWP
 * @author webcat
 */
//#################################################################
if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) { die('You are not allowed to call this page directly.'); }
//#################################################################
if (!class_exists('googlemapsForWPDB')){
/**
 * googlemapsForWP maps
 * The class provides access to
 */
	 class googlemapsForWPDB {
            function __construct(){}
/**
 *
 * @global connection $wpdb 
 */
              function install(){
                global $wpdb;
                     $line=$wpdb->query("CREATE TABLE IF NOT EXISTS wp_googlemapsforwp(
                        `id` int(11) AUTO_INCREMENT NOT NULL,
                        `mapname` varchar( 25 ) NOT NULL DEFAULT 'Cardiff',
                        `mapdescription` varchar( 300 )DEFAULT 'map',
                        `zoom` text NOT NULL,
                        `size` text NOT NULL,
                        `type` varchar(10) DEFAULT 'roadmap',
                        `format` varchar(7) DEFAULT 'png24',
                        `sensor` varchar (5) DEFAULT 'false',
                        `js` varchar(5) DEFAULT 'false',
                        PRIMARY KEY ( `id` )) ENGINE=InnoDB;");
                     $line= $wpdb->query("CREATE TABLE IF NOT EXISTS wp_googlemapsforwp_flags(
                        `id` int(11) AUTO_INCREMENT NOT NULL,
                        `latitude` varchar(10) DEFAULT '51.477222',
                        `longitude` varchar(10) DEFAULT '0',
                        `last_update` TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                        `map` int(11) NOT NULL,
                        `type` varchar (20) NOT NULL DEFAULT 'center',
                        `size` varchar (20) NOT NULL DEFAULT 'small',
                        `colour` varchar (10) NOT NULL DEFAULT 'red',
                        `note` varchar (500),
                        `title` varchar(140),
                        PRIMARY KEY ( `id` )) ENGINE=InnoDB; ");
                     
            }
/**
 *
 * @global connection $wpdb 
 */
            function uninstall(){
                global $wpdb;
                $wpdb->query("DROP TABLE IF EXISTS wp_googlemapsforwp;");
                $wpdb->query("DROP TABLE IF EXISTS wp_googlemapsforwp_flags;");
            }
/**
 * 
 */
             function updateTables(){
                global $wpdb;
                $wpdb->query("RENAME TABLE wp_googlemapsForWP TO wp_googlemapsforwp;");
                $wpdb->query("RENAME TABLE wp_googlemapsForWP_flags TO wp_googlemapsforwp_flags;");
                $wpdb->query("ALTER TABLE wp_googlemapsforwp ADD `js` VARCHAR(5) NOT NULL DEFAULT 'true' AFTER `sensor`;");
                $wpdb->query("ALTER TABLE wp_googlemapsforwp_flags ADD `title` VARCHAR(500) AFTER `note`;");
            }
            
            function installed(){
                global $wpdb;
                $wpdb->flush;
                $installed=$wpdb->query("SELECT `mapname` FROM wp_googlemapsforwp;");
                if($installed===false ){ return false;}
                return true;
            }
/**
 *
 * @global connection $wpdb
 * @param array $args
 * @return array
 */
            function addMap($args){
                global $wpdb;
                foreach($args as $key => $value){
                    $args[$key]= $wpdb->escape($value);
                }
                $size=$args['sizewidth']."x".$args['sizeheight'];
                $wpdb->insert('wp_googlemapsForWP',array('mapname'=>$args['mapname'],'mapdescription'=>$args['mapdescription'],'zoom'=>$args['zoom'],'size'=>$size,'type'=>$args['type'],'format'=>$args['format'],'sensor'=>$args['sensor'],'js'=>$args['js']));
                $mapnumber=$wpdb->insert_id;
                $wpdb->insert('wp_googlemapsForWP_flags',array('longitude' => $args['longitude'],'latitude'=>$args['latitude'],'map'=>$mapnumber,'type'=>'center'));
                return $mapnumber;
            }
/**
 *
 * @global connection $wpdb
 * @param array $args
 * @return array
 */
            function updateMap($id,$args){
                global $wpdb;$line=true;
                foreach($args as $key => $value){
                    $args[$key] = $wpdb->escape($value);
                }
                $size=$args['sizewidth']."x".$args['sizeheight'];
                try{
                    $query="UPDATE wp_googlemapsforwp SET
                       `mapname`='".$args['mapname']."',
                       `mapdescription`='". $args['mapdescription']."',
                       `zoom`= ".$args['zoom'].",
                       `size`='".$size."',
                       `type`='".$args['type']."',
                       `format`='".$args['format']."',
                       `sensor`='".$args['sensor']."',
                       `js`='".$args['js']."'
                       WHERE `id` =".$id.";";
                   $line=$wpdb->query($query);
                   if($line===false){throw new Exception("Query is ".$query." ".$line."Map ");}
                   $line=true;
                   $query2="UPDATE wp_googlemapsforwp_flags SET
                       `longitude` = '".$args['longitude']."',
                       `latitude`='".$args['latitude']."'
                       WHERE `map` = ".$id." AND `type` = 'center';";
                   $line=$wpdb->query($query2);
                if($line===false){throw new Exception("Query is ".$query2." "."Flag ");}
                }catch(Exception $e){
                    throw $e;
                }
            }
/**
 *
 * @global connection $wpdb
 * @param <type> $id 
 */
            function deleteMap($id){
                global $wpdb;
                $wpdb->query("DELETE FROM wp_googlemapsforwp_flags WHERE map = ".$id.";");
                $wpdb->query("DELETE FROM wp_googlemapsforwp WHERE id = ".$id.";");
            }
/**
 *
 * @global connection $wpdb
 * @param <type> $mapnumber
 * @param <type> $long
 * @param <type> $lat
 * @param <type> $size
 * @param <type> $colour
 * @param <type> $note 
 */
            function addFlag($args){
                //$map, $long, $lat, $size, $colour, $note, $title
                global $wpdb;
                foreach($args as $key => $value){
                    $args[$key]=($wpdb->escape($value));
                }
                $wpdb->insert('wp_googlemapsforwp_flags',$args);
                return $wpdb->insert_id;
            }
/**
 *
 * @global connection $wpdb
 * @param <type> $mapnumber
 * @param <type> $long
 * @param <type> $lat
 * @param <type> $size
 * @param <type> $colour
 * @param <type> $note
 */
            function updateFlag($flagid,$args){echo "in";
                //$map, $long, $lat, $size, $colour, $note, $title
                global $wpdb;$line=true;
                foreach($args as $key => $value){
                    $args[$key]=($wpdb->escape($value));
                }
                $query2="UPDATE wp_googlemapsforwp_flags SET
                       `longitude` = '".$args['longitude']."',
                       `latitude`='".$args['latitude']."',
                       `map` = '".$args['map']."',
                       `type` = '".$args['type']."',
                       `size` = '".$args['size']."',
                       `colour` = '".$args['colour']."',
                       `note` = '".$args['note']."',
                       `title` = '".$args['title']."'
                       WHERE `id` = ".intval($flagid)." AND `type` = 'flag';";
               $line=$wpdb->query($query2);
               if($line===false){throw new Exception("Query is ".$query2." ".$line."Map ");}
                   return $line;
            }
/**
 *
 * @global connection $wpdb
 * @param <type> $mapid
 * @return <type> 
 */
            function getFlags($mapid){
                global $wpdb;
                $flags=$wpdb->get_results("SELECT * FROM wp_googlemapsforwp_flags WHERE map = ".$mapid." AND type='flag';",ARRAY_A);
                foreach($flags as $key => $value){
                    $flags[$key]=$value;
                }
                return $flags;
            }
/**
 *
 * @global connection $wpdb
 * @param <type> $id 
 */
            function deleteFlag($id){
               global $wpdb;
                $wpdb->query("DELETE FROM wp_googlemapsforwp_flags WHERE id = ".$id.";");
            }
/**
 *
 * @global connection $wpdb
 * @param <type> $id
 * @return <type> 
 */
            function getMap($id){
                global $wpdb;
                $mapdata=$wpdb->get_results("SELECT mapname,mapdescription,zoom,a.size,a.type,format,sensor,latitude,longitude,js
                        FROM `wp_googlemapsforwp` a LEFT JOIN `wp_googlemapsforwp_flags` b
                        ON a.id = b.map AND b.type = 'center'
                        WHERE a.id = ".$id.";",ARRAY_A);
                foreach($mapdata as $index=>$map){
                    foreach($map as $key => $value){
                        $map[$key]=stripslashes($value);
                    }
                    $mapdata[$index]=$map;
                }
                return $mapdata;
            }
/**
 *
 * @global connection $wpdb
 * @return <type> 
 */
            function getMapList(){
                global $wpdb;
                $maplist=$wpdb->get_results("SELECT id,mapname FROM wp_googlemapsforwp;",ARRAY_A);
                foreach($maplist as $index=>$map){
                    foreach($map as $key => $value){
                        $map[$key]=stripslashes($value);
                    }
                    $maplist[$index]=$map;
                }
                return $maplist;//array('name1','name2');
            }
         }
}
?>