<?php
/**
 * @package googlemapsForWP
 */
/*
  Plugin Name: googlemapsForWP
  Plugin URI: http://www.rachel-webcat.com/
  Description: Simple plugin that allows wordpress administrators to store parameters for multiple googlemaps on their wordpress blog
 * and easily use those maps in posts/allow users to use the stored maps
  Author: webcat
  Version: 6.1
  Author URI: http://www.rachel-webcat.com/
 */
//#################################################################
// Stop direct call
if (preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) {
    die('You are not allowed to call this page directly.');
}
//#################################################################
if (!class_exists('googlemapsForWP')) {

    /**
     * Main class for the plugin
     *
     * sets up all the links into wordpress and provides access to the output functions
     */
    class googlemapsForWP {

        /**
         * @static string used to check the version of wuwur being used
         * @todo function to update plugin
         */
        public static $googlemapsForWPVersion = 6.1;
        /**
         *
         * @var string
         */
        public static $googlemapsForWPCredits = "googlemapsForWP";
        /**
         *
         * @var string
         */
        public static $googlemapsForWPAuthor = "webcat";
        /**
         *
         * @var string
         */
        public static $googlemapsForWPURL = "http://www.rachel-webcat.com/googlemapsForWP";
        /**
         *
         * @return string value of this plugins directory
         */
        public static function filePath() {
            $url = get_settings('siteurl') . '/wp-admin/admin-ajax.php?action=fail&reason=';
            return $url;
        }
        /**
         *
         * @return string value of this plugins directory
         */
        public static function pluginDir() {
            return str_replace("googlemapsForWP.php", "", __FILE__);
        }
        /**
         *
         * @return string value of this plugins url
         */
        public static function pluginURL() {
            $url = get_settings('siteurl') . '/wp-content/plugins/googlemapsforp/';
            return $url;
        }
        /**
         * @static method to get url for ajax calls
         */
        public static function ajaxURL() {
            $temp = get_settings('siteurl') . "/wp-admin/admin-ajax.php";
            return $temp;
        }
        /**
         *
         */
        public static function update() {
            googlemapsForWP::getFile('data', 'mapdata.php');
            $db = new googlemapsForWPDB();
            $db->updateTables();
            update_option("googlemapsForWPversion", googlemapsForWP::$googlemapsForWPVersion);
			$db=null;
        }
        /**
         * @static method to activate plugin
         * @uses googlemapsForWPDBSetup install
         */
        public static function register() {
            if((( $_GET['action'] )=='update_selected' || ( $_GET['action'] )=='upgrade-plugin')|| get_option("googlemapsForWPversion") < googlemapsForWP::$googlemapsForWPVersion ){
                googlemapsForWP::update();
            }else{
                googlemapsForWP::getFile('data', 'mapdata.php');
                $db = new googlemapsForWPDB();
                $db->install();
            }
        }
        /**
         * @static method to deactivate plugin
         * @uses googlemapsForWPDBSetup uninstall()
         */
        public static function uninstall() {
            if ( __FILE__ != WP_UNINSTALL_PLUGIN ){
                return;
            }else{
                googlemapsForWP::getFile('data', 'mapdata.php');
                $db = new googlemapsForWPDB();
                $db->uninstall();
            }
        }
        /**
         * generic function to catch errors from missing files
         * @param <type> $path
         * @param <type> $file
         * @param <type> $require
         * @return <type>
         */
        public static function getFile($path,$file,$require=true){
                if (!file_exists(googlemapsForWP::pluginDir() . DIRECTORY_SEPARATOR . $path . DIRECTORY_SEPARATOR . $file)) {
                    throw new Exception('Cannot find the required files');
                } else {
                    if($require){
                        require_once(googlemapsForWP::pluginDir() . DIRECTORY_SEPARATOR . $path . DIRECTORY_SEPARATOR . $file);
                    }else{
                        include_once(googlemapsForWP::pluginDir() . DIRECTORY_SEPARATOR . $path . DIRECTORY_SEPARATOR . $file);
                    }
                }
        }
        /*
         * Admin page
         */

        protected $googlemapsForWPadminpage;
        protected $googlemapsForWPvisitor;

        function __construct() {
            try {
                if (is_admin ()) {
                    googlemapsForWP::getFile('ui', 'googlemapsForWPAdmin.php');
                    $this->googlemapsForWPadminpage = new googlemapsForWPAdminPage;
                    add_action('admin_menu', array($this, 'googlemapsForWPAdmin'));
                    register_activation_hook(__FILE__, 'googlemapsForWP::register');
                    register_uninstall_hook(__FILE__, 'googlemapsForWP::uninstall');
                }else{
                googlemapsForWP::getFile('ui', 'googlemapsForWPVisitor.php');
                $this->googlemapsForWPvisitor = new googlemapsForWPVisitor();
                }
                //add_action('admin_enqueue_scripts', array($this, 'scripts'));
            } catch (Exception $e) {
                    $current = get_settings('active_plugins');
                    array_splice($current, array_search( $_POST['plugin'], $current), 1 ); // Array-function!
                    update_option('active_plugins', $current);
                    header('Location: plugins.php?deactivate=true');
            }
        }
        /**
         * Used by constructor to create the wordpress menu items for settings and events
         * @usedby googlemapsForWP
         */
        function googlemapsForWPAdmin() {
            if (function_exists('add_options_page')) {
                $this->googlemapsForWPadminpage->add_menu();
            }
        }
    }

    $googlemapsForWP = new googlemapsForWP;
}
?>